#!/usr/bin/env python
# coding: utf-8



B="B"#black
W="W"#white
N=8#nb de lignes


def list2string(l:list[str])->str:
    return "".join(l)

def string2list(s:str)->list[str]:
    return [c for c in s]


# In[3]:


s="...........................WB......BW.............................."
print(string2list(s[25:40]))
print(list2string(string2list(s)))


# Q1


# In[6]:


#**********
def pos2coords (x:int)->tuple[int,int] :
    return (x//N,x%N)


# In[7]:


pos2coords(10) ,pos2coords(28)


# In[8]:


#Q2
# ********
def coords2pos (i:int,j:int)->int:
    return N*i + j



# Q3





# ********
def get (g:str,i:int,j:int)->str:
    return g[coords2pos(i,j)]
    


# In[12]:


g="...........................WB......BW.............................."
get(g,3,4)



# Q4


# In[14]:


#********
def set_str(g:str,i:int,j:int,c:str)->str:
    l = string2list(g)
    l[coords2pos(i,j)]=c
    return list2string(l)

g="...........................WB......BW.............................."
print(set_str(g,3,4,W))


#Q5





#********
def other (J):
    assert (J==B or J==W)
    if J==B :return W
    return B


other(W),other(B)


#Q6


# In[20]:


#**********
def init()->tuple[str,str]:
    l=['.']*N**2
    l[coords2pos(N//2-1,N//2-1)]=W
    l[coords2pos(N//2-1,N//2)]=B
    l[coords2pos(N//2,N//2)]=W
    l[coords2pos(N//2,N//2-1)]=B
    return B,list2string(l)



# Q7


# In[23]:


#*********
def sort(c1:tuple[int,int],c2:tuple[int,int])->tuple[tuple[int,int],tuple[int,int]]:
    if c1<=c2:
        return c1,c2
    return c2,c1


print(sort((1,3),(0,4))) 
print(sort((1,3),(1,2)))
print(sort((1,3),(2,0)))


#Q8


def _row_ok(g,c1,c2,v): # c1<=c2; c1 et c2 sur une mme ligne
    if abs(c1[1]-c2[1])<=1:return False
    for j in range(c1[1]+1,c2[1]):
        if get(g,c1[0],j)!=v:return False
    return True

def _col_ok(g,c1,c2,v): # c1<=c2; mme col
    if abs(c1[0]-c2[0])<=1:return False
    for i in range(c1[0]+1,c2[0])
        if get(g,i,c1[1])!=v:return False
    return True

def _diag_ok(g,c1,c2,v):#c1<=c2; mme diag; c1[1]+1<c2[1]
    if abs(c1[1]-c2[1])<=1 and abs(c1[0]-c2[0])<=1:return False
    for k in range(1,c2[1]-c1[1]):
        if get(g,c1[0]+k,c1[1]+k)!=v:return False
    return True

def _anti_diag_ok(g,c1,c2,v):#c1<=c2; mme anti-diag; c1[1]>c2[1]+1
    if abs(c1[1]-c2[1])<=1 and abs(c1[0]-c2[0])<=1:return False
    for k in range(1,c1[1]-c2[1]):
        if get(g,c1[0]+k,c1[1]-k)!=v:return False
    return True

def line (g:str,c1:tuple[int,int],c2:tuple[int,int],v:str)->bool:
    c1,c2=sort(c1,c2)
    if c1[0]==c2[0]: return _row_ok(g,c1,c2,v)
    if c1[1]==c2[1]: return _col_ok(g,c1,c2,v)
    if c2[0]-c1[0] == c2[1]-c1[1] : return _diag_ok(g,c1,c2,v)
    if c2[0]-c1[0] == c1[1]-c2[1] : return _anti_diag_ok(g,c1,c2,v)
    return False
    
    
    


# In[27]:


l = ['.']*N**2
g = list2string(l)
g=set_str(g,5,1,W);g=set_str(g,4,2,B)
g=set_str(g,3,3,B);g=set_str(g,2,4,B)
g=set_str(g,1,5,W);
print(line(g,(5,1),(1,5),B))
g=set_str(g,2,4,'.')
print(line(g,(5,1),(1,5),B))
print(line(g,(5,1),(4,2),B))


# In[28]:


print(g)


# In[29]:


l = ['.']*N**2
g = list2string(l)
g=set_str(g,5,1,W)
g=set_str(g,4,2,B)
g=set_str(g,3,3,B)
g=set_str(g,2,4,'.')
g=set_str(g,1,5,W)
line(g,(5,1),(1,5),B)


# # Q9
# 
# Attention, quand on teste qu'une ligne est de couleur `autre`, il
# faut que les extrêmités soient de la couleur du joueur


#**********
"""
p vaut W ou B
g est une grille sous forme de str
c est la position où on envisage de jouer

A compléter sur la copie !!
"""



def can_play(p:str,g:str,c:tuple[int,int])->bool:
    o = other(p)#autre couleur
    if g[coords2pos(*c)]!='.': return False    
    for j in range(0,N):#analyse de la ligne de c
        if j!=c[1] and line(g,c,(c[0],j),o) and get(g,c[0],j)==p: return True
    for i in range(0,N):#analyse de col 
        if i!=c[0] and line(g,c,(i,c[1]),o) and get(g,i,c[1])==p: return True
    i,j=c[0]-1,c[1]-1
    while i>=0 and j>=0:#diagonale vers le haut
        if line(g,c,(i,j),o) and get(g,i,j)==p: return True
        i,j=i-1,j-1
    i,j=c[0]+1,c[1]+1
    while i<N and j<N:#diagonale vers le bas
        if line(g,c,(i,j),o) and get(g,i,j)==p: return True
        i,j=i+1,j+1
    i,j=c[0]-1,c[1]+1
    while i>=0 and j<N:#anti-diagonale vers le haut
        if line(g,c,(i,j),o) and get(g,i,j)==p: return True
        i,j=i-1,j+1
    i,j=c[0]+1,c[1]-1
    while i<N and j>=0:#anti-diagonale vers le bas
        if line(g,c,(i,j),o) and get(g,i,j)==p: return True
        i,j=i+1,j-1
    return False



_,g=init()
g=set_str(g,3,3,B)
g=set_str(g,2,3,B)
print(g)
#g est dans la situation de la figure 2
can_play(W,g,(5,3)), can_play(W,g,(3,2)),can_play(W,g,(2,2)),can_play(B,g,(2,2))


# Q10

#************
def str2mat(g:str)->list[list[str]]:
    m = [['.']*N for _ in range(N)]
    for i in range(N):
        for j in range(N):
            m[i][j]=get(g,i,j)
    return m


_,g = init()
str2mat(g)


#Q11

#**********
def mat2str(m:list[list[str]])->str:
    flat=[]
    for i in range(len(m)):
        for j in range(len(m[0])):
            flat.append(m[i][j])
    return list2string(flat)

def mat2str(m:list[list[str]])->str:#V2 avec extend
    flat=[]
    for ligne in m:
        flat.extend(ligne)
    return list2string(flat)


_,g = init()
m=str2mat(g)
mat2str(m)


# Q12


#***********
def set_mat(m:list[list[str]],c1:tuple[int,int],c2:tuple[int,int],p:str)->None:
        c1,c2=sort(c1,c2)
        if c1[0]==c2[0]:
            for j in range(c1[1]+1,c2[1]): m[c1[0]][j]=p
        elif c1[1]==c2[1]:
            for i in range(c1[0]+1,c2[0]): m[i][c1[1]]=p
        elif c2[0]-c1[0]==c2[1]-c1[1]:#diagonale
            for k in range(1,c2[0]-c1[0]):m[c1[0]+k][c1[1]+k]=p
        elif  c2[0]-c1[0]==c1[1]-c2[1]:#anti_diagonale
            for k in range(1,c2[0]-c1[0]):m[c1[0]+k][c1[1]-k]=p       


_,g=init()
m = str2mat(g)
print(can_play(B,g,(2,3)))
print(line(g,(2,3),(4,3),W))
set_mat(m,(2,3),(4,3),B)
m


get(g,2,3),get(g,3,3)


# Q13

def play(p:str,g:str,c:tuple[int,int])->tuple[str,str]:
    assert (can_play(p,g,c))
    m=str2mat(g)
    m[c[0]][c[1]]=p
    for i in range(N):
        for j in range(N):
            if line(g,c,(i,j),other(p)) and p == get(g,i,j):
                #print(i,j)
                set_mat(m,c,(i,j),p)
    return (other(p),mat2str(m))
    


# On parcourt tous les coefs de la matrice et on vérifie que la case
# courante forme une ligne (par `line`) avec `c`.
# 
# On peut sans doute améliorer la complexité en partant de `c` et en
# se déplaçant dans les 8 directions cardinales.

# In[44]:


p1,g1=init()
print(p1)
c=(2,3)
p2,g2=play(p1,g1,c)
print(p2)
str2mat(g2)


# In[45]:


print(can_play(W,g2,(2,2)))
print(line(g2,(2,2),(4,4),B))


# In[46]:


p3,g3=play(p2,g2,(2,2))
print(p3)
str2mat(g3)


# In[47]:


p4,g4=play(p3,g3,(3,2))
print(p4)
str2mat(g4)


# In[48]:


p5,g5=play(p4,g4,(4,2))
print(p5)
str2mat(g5)


# In[49]:


# Q14



#********
def next_pos(p:str,g:str)->list[tuple[int,int]]:
    res = []
    for i in range(N):
        for j in range(N):
            if can_play(p,g,(i,j)):
                res.append((i,j))
    return res



p,g=init()
next_pos(p,g)



# Q15


# In[53]:


def next_states(p:str,g:str)->list[tuple[str,str]]:
    cases = next_pos(p,g)
    res = []
    for c in cases:
        res.append(play(p,g,c))
    if res != []: return res
    #si res est vide, l'autre joueur peut peut-être jouer
    cases2=next_pos(other(p),g)
    if cases2==[]:return []
    return [(other(p),g)]
    


p,g=init()
next_states(p,g)


# Q16


#**********
def end(g:str)->bool:
    return next_pos(p,g)==[] and next_pos(other(p),g)==[]


# Q17



#***********

def _compte(g:str)->tuple[int,int]:
    cptB=cptW=0
    for i in range(N):
        for j in range(N):
            if get(g,i,j)==W:cptW+=1
            if get(g,i,j)==B:cptB+=1
    return cptB,cptW
    

def outcome(p:str,g:str)->str:
    assert(end(g))
    cptB,cptW=_compte(g)
    if cptB>cptW:return B
    elif cptB<cptW:return W


p,g=init()
m = str2mat(g)
for i in range(N):
    for j in range(N):
        if j>=i-2:m[i][j]=W
        else:m[i][j]=B
m


outcome(W,mat2str(m))


p,g=init()
m = str2mat(g)
for i in range(N):
    for j in range(N):
        if j>=i-2:m[i][j]=W
        else:m[i][j]=B
m[0][N-2]=='.'
m


#Q22


#***********
"""
simple minmax
"""
def minmax(e:tuple[str,str])->int:
    if end(e[1]):
        r=outcome(*e)
        if r == B:return 1
        if r == W:return -1
        if r is None : return 0
    states = next_states(*e)#états voisins de e
    f = min if e[0]==W else max
    return f([minmax(etat) for etat in states])
    
        
        


# In[64]:


#minmax(init())#-1 avec N=4



# Q23

#***********

compter = _compte


p1,g1=init()
print(p1)
c=(2,3)
p2,g2=play(p1,g1,c)
print(p2)
str2mat(g2)


# In[67]:


compter(g2)


# In[68]:


#Q24

#*******

#Attention à ne pas compter 2 fois les coins !

def bords(g:str)->tuple[int,int]:
    cptB=cptW=0
    for i in range(N):
        if get(g,i,0)==W:cptW+=1
        if get(g,i,0)==B:cptB+=1
        if get(g,i,N-1)==W:cptW+=1
        if get(g,i,N-1)==B:cptB+=1
    for j in range(N):
        if j!=0 and j!=N-1:
            if get(g,0,j)==W:cptW+=1
            if get(g,0,j)==B:cptB+=1
            if get(g,N-1,j)==W:cptW+=1
            if get(g,N-1,j)==B:cptB+=1
    return cptB,cptW


#Q25

#********
def coins(g:str)->tuple[int,int]:
    cptB=cptW=0
    for i,j in [(0,0),(N-1,0),(0,N-1),(N-1,N-1)]:
        if get(g,i,j)==W:cptW+=1
        if get(g,i,j)==B:cptB+=1
    return cptB,cptW
    


# In[70]:


#q26
def h(g:str)->int:
    c1,c2=compter(g)
    c3,c4=bords(g)
    c5,c6=coins(g)
    return c1+3*c3+10*c5-c2-3*c4-10*c6


#q27
#*********
from typing import Callable

"""
e : état
h : heuristique
d : profondeur
"""
def minmax_hd(e:tuple[str,str],h:Callable[[str],int],d:int)->int:
    if end(e[1]):
        r=outcome(*e)
        if r == B:return 1
        if r == W:return -1
        if r is None : return 0
    if d==0:
        return h(e[1])
    states = next_states(*e)
    f = min if e[0]==W else max
    return f([minmax_hd(etat,h,d-1) for etat in states])


# In[82]:


import time
t1 = time.time()
score = minmax_hd(init(),h,7)
t2 = time.time()
print("score={} obtenu en {}s".format(score,t2-t1))
